searchNodes=[{"ref":"VintageNet.html","title":"VintageNet","type":"module","doc":"VintageNet is network configuration library built specifically for Nerves Project devices. It has the following features: Ethernet and WiFi support included. Extendible to other technologies Default configurations specified in your Application config Runtime updates to configurations are persisted and applied on next boot (can be disabled) Simple subscription to network status change events Connect to multiple networks at a time and prioritize which interfaces are used (Ethernet over WiFi over cellular) Internet connection monitoring and failure detection (currently slow and simplistic) See github.com/nerves-networking/vintage_net for more information."},{"ref":"VintageNet.html#all_interfaces/0","title":"VintageNet.all_interfaces/0","type":"function","doc":"Return a list of all interfaces on the system"},{"ref":"VintageNet.html#configuration_valid?/2","title":"VintageNet.configuration_valid?/2","type":"function","doc":"Check if this is a valid configuration This runs the validation routines for a settings map, but doesn&#39;t try to apply them."},{"ref":"VintageNet.html#configure/3","title":"VintageNet.configure/3","type":"function","doc":"Update the configuration of a network interface Configurations are validated and normalized before being applied. This means that type errors and missing required fields will be caught and old or redundant ways of specifying configurations will be fixed. Call get_configuration/1 to see how what changes, if any, were made as part of the normalization process. After validation, the configuration is optionally persisted and applied. See the VintageNet documentation for configuration examples or your VintageNet.Technology provider&#39;s docs. Options: :persist - set to false to avoid persisting this configuration. System restarts will revert to the previous configuration."},{"ref":"VintageNet.html#configured_interfaces/0","title":"VintageNet.configured_interfaces/0","type":"function","doc":"Return a list of configured interface"},{"ref":"VintageNet.html#deconfigure/2","title":"VintageNet.deconfigure/2","type":"function","doc":"Deconfigure settings for a specified interface. Supports same options as configure/3"},{"ref":"VintageNet.html#get/2","title":"VintageNet.get/2","type":"function","doc":"Get the current value of a network property See get_by_prefix/1 for exact prefix matches (i.e., get all properties for one interface) and match/1 to run wildcard matches (i.e., get a specific property for all interfaces)."},{"ref":"VintageNet.html#get_by_prefix/1","title":"VintageNet.get_by_prefix/1","type":"function","doc":"Get a list of all properties matching the specified prefix To get a list of all known properties and their values, call VintageNet.get_by_prefix([])"},{"ref":"VintageNet.html#get_configuration/1","title":"VintageNet.get_configuration/1","type":"function","doc":"Return the settings for the specified interface"},{"ref":"VintageNet.html#info/1","title":"VintageNet.info/1","type":"function","doc":"Print the current network status Options include: :redact - Set to false to print out passwords"},{"ref":"VintageNet.html#ioctl/3","title":"VintageNet.ioctl/3","type":"function","doc":"Run a command on a network interface Commands are mostly network interface-specific. Also see the VintageNet PropertyTable fo getting status or registering for status changes."},{"ref":"VintageNet.html#match/1","title":"VintageNet.match/1","type":"function","doc":"Get a list of all properties matching a pattern Patterns are list of strings that optionally specify :_ at a position in the list to match any value."},{"ref":"VintageNet.html#max_interface_count/0","title":"VintageNet.max_interface_count/0","type":"function","doc":"Return the maximum number of interfaces controlled by VintageNet Internal constraints mean that VintageNet can&#39;t manage an arbitrary number of interfaces and knowing the max can reduce some processing. The limit is set by the application config. Unless you need over 100 network interfaces, VintageNet&#39;s use of the Linux networking API is not likely to be an issue, though."},{"ref":"VintageNet.html#scan/1","title":"VintageNet.scan/1","type":"function","doc":"Initiate an access point scan on a wireless interface The scan results are posted asynchronously to the [&quot;interface&quot;, ifname, &quot;wifi&quot;, &quot;access_points&quot;] property as they come in. It appears that there&#39;s some variation in how scanning is implemented on WiFi adapters. One strategy that seems to work is to call scan/1 every 10 seconds or so while prompting a user to pick a WiFi network. This is a utility function for calling the :scan ioctl."},{"ref":"VintageNet.html#subscribe/1","title":"VintageNet.subscribe/1","type":"function","doc":"Subscribe to property change messages Messages have the form: {VintageNet, property_name, old_value, new_value, metadata} Subscriptions are prefix matches. For example, to get notified whenever a property changes on &quot;wlan0&quot;, run this: VintageNet.subscribe([&quot;interface&quot;, &quot;wlan0&quot;]) It&#39;s also possible to match with wildcards using :_. For example, to get notified whenever an IP address in the system changes, do this: VintageNet.subscribe([&quot;interface&quot;, :_, &quot;addresses&quot;])"},{"ref":"VintageNet.html#unsubscribe/1","title":"VintageNet.unsubscribe/1","type":"function","doc":"Stop subscribing to property change messages"},{"ref":"VintageNet.html#verify_system/1","title":"VintageNet.verify_system/1","type":"function","doc":"Check that the system has the required programs installed NOTE: This isn&#39;t completely implemented yet!"},{"ref":"VintageNet.html#t:any_ip_address/0","title":"VintageNet.any_ip_address/0","type":"type","doc":"IP addresses in VintageNet can be specified as strings or tuples While VintageNet uses IP addresses in tuple form internally, it can be cumbersome to always convert to tuple form in practice. The general rule is that VintageNet is flexible in how it accepts IP addresses, but if you get an address from a VintageNet API, it will be in tuple form."},{"ref":"VintageNet.html#t:configure_options/0","title":"VintageNet.configure_options/0","type":"type","doc":"Valid options for VintageNet.configure/3 :persist - Whether or not to save the configuration (defaults to true)"},{"ref":"VintageNet.html#t:ifname/0","title":"VintageNet.ifname/0","type":"type","doc":"A name for the network interface Names depend on the device drivers and any software that may rename them. Typical names on Nerves are: &quot;eth0&quot;, &quot;eth1&quot;, etc. for wired Ethernet interfaces &quot;wlan0&quot;, etc. for WiFi interfaces &quot;ppp0&quot; for cellular modems &quot;usb0&quot; for gadget USB virtual Ethernet interfaces"},{"ref":"VintageNet.html#t:info_options/0","title":"VintageNet.info_options/0","type":"type","doc":"Valid options for VintageNet.info/1 :redact - Whether to hide passwords and similar information from the output (defaults to true)"},{"ref":"VintageNet.html#t:ipv4_prefix_length/0","title":"VintageNet.ipv4_prefix_length/0","type":"type","doc":"The number of bits to use for an IPv4 subnet For example, if you have a subnet mask of 255.255.255.0, then the prefix length would be 24."},{"ref":"VintageNet.html#t:ipv6_prefix_length/0","title":"VintageNet.ipv6_prefix_length/0","type":"type","doc":"The number of bits to use for an IPv6 subnet"},{"ref":"VintageNet.html#t:prefix_length/0","title":"VintageNet.prefix_length/0","type":"type","doc":"The number of IP address bits for the subnet"},{"ref":"VintageNet.IP.html","title":"VintageNet.IP","type":"module","doc":"This module contains utilities for handling IP addresses. By far the most important part of handling IP addresses is to pay attention to whether your addresses are names, IP addresses as strings or IP addresses at tuples. This module doesn&#39;t resolve names. While IP addresses in string form are convenient to type, nearly all Erlang and Elixir code uses IP addresses in tuple form."},{"ref":"VintageNet.IP.html#cidr_to_string/2","title":"VintageNet.IP.cidr_to_string/2","type":"function","doc":"Convert an IP address w/ prefix to a CIDR-formatted string Examples: iex&gt; VintageNet.IP.cidr_to_string({192, 168, 0, 1}, 24) &quot;192.168.0.1/24&quot;"},{"ref":"VintageNet.IP.html#ip_to_string/1","title":"VintageNet.IP.ip_to_string/1","type":"function","doc":"Convert an IP address to a string Examples: iex&gt; VintageNet.IP.ip_to_string({192, 168, 0, 1}) &quot;192.168.0.1&quot; iex&gt; VintageNet.IP.ip_to_string(&quot;192.168.9.1&quot;) &quot;192.168.9.1&quot; iex&gt; VintageNet.IP.ip_to_string({65152, 0, 0, 0, 0, 0, 0, 1}) &quot;fe80::1&quot;"},{"ref":"VintageNet.IP.html#ip_to_tuple/1","title":"VintageNet.IP.ip_to_tuple/1","type":"function","doc":"Convert an IP address to tuple form Examples: iex&gt; VintageNet.IP.ip_to_tuple(&quot;192.168.0.1&quot;) {:ok, {192, 168, 0, 1}} iex&gt; VintageNet.IP.ip_to_tuple({192, 168, 1, 1}) {:ok, {192, 168, 1, 1}} iex&gt; VintageNet.IP.ip_to_tuple(&quot;fe80::1&quot;) {:ok, {65152, 0, 0, 0, 0, 0, 0, 1}} iex&gt; VintageNet.IP.ip_to_tuple({65152, 0, 0, 0, 0, 0, 0, 1}) {:ok, {65152, 0, 0, 0, 0, 0, 0, 1}} iex&gt; VintageNet.IP.ip_to_tuple(&quot;bologna&quot;) {:error, &quot;Invalid IP address: bologna&quot;}"},{"ref":"VintageNet.IP.html#ip_to_tuple!/1","title":"VintageNet.IP.ip_to_tuple!/1","type":"function","doc":"Raising version of ip_to_tuple/1"},{"ref":"VintageNet.IP.html#prefix_length_to_subnet_mask/2","title":"VintageNet.IP.prefix_length_to_subnet_mask/2","type":"function","doc":"Convert an IPv4 or IPv6 prefix length to a subnet mask. Examples: iex&gt; VintageNet.IP.prefix_length_to_subnet_mask(:inet, 24) {255, 255, 255, 0} iex&gt; VintageNet.IP.prefix_length_to_subnet_mask(:inet, 28) {255, 255, 255, 240} iex&gt; VintageNet.IP.prefix_length_to_subnet_mask(:inet6, 64) {65535, 65535, 65535, 65535, 0, 0, 0, 0}"},{"ref":"VintageNet.IP.html#subnet_mask_to_prefix_length/1","title":"VintageNet.IP.subnet_mask_to_prefix_length/1","type":"function","doc":"Convert an IPv4 subnet mask to a prefix length. Examples: iex&gt; VintageNet.IP.subnet_mask_to_prefix_length({255, 255, 255, 0}) {:ok, 24} iex&gt; VintageNet.IP.subnet_mask_to_prefix_length({192, 168, 1, 1}) {:error, &quot;{192, 168, 1, 1} is not a valid IPv4 subnet mask&quot;}"},{"ref":"VintageNet.IP.html#to_subnet/2","title":"VintageNet.IP.to_subnet/2","type":"function","doc":"Utility function to trim an IP address to its subnet Examples: iex&gt; VintageNet.IP.to_subnet({192, 168, 1, 50}, 24) {192, 168, 1, 0} iex&gt; VintageNet.IP.to_subnet({192, 168, 255, 50}, 22) {192, 168, 252, 0}"},{"ref":"VintageNet.IP.DhcpdConfig.html","title":"VintageNet.IP.DhcpdConfig","type":"module","doc":"This is a helper module for VintageNet.Technology implementations that use a DHCP server. DHCP server parameters are: :start - Start of the lease block :end - End of the lease block :max_leases - The maximum number of leases :decline_time - The amount of time that an IP will be reserved (leased to nobody) :conflict_time -The amount of time that an IP will be reserved :offer_time - How long an offered address is reserved (seconds) :min_lease - If client asks for lease below this value, it will be rounded up to this value (seconds) :auto_time - The time period at which udhcpd will write out leases file. :static_leases - list of {mac_address, ip_address} :options - a map DHCP response options to set. See below. DHCP response options are (see RFC 2132 for details): :dns - IP_LIST :domain - STRING - [0x0f] client&#39;s domain suffix :hostname - STRING :mtu - NUM :router - IP_LIST :search - STRING_LIST - [0x77] search domains :serverid - IP (defaults to the interface&#39;s IP address) :subnet - IP Options may also be passed in as integers. These are passed directly to the DHCP server and their values are strings that are not interpreted by VintageNet. Use this to support custom DHCP header options."},{"ref":"VintageNet.IP.DhcpdConfig.html#add_config/3","title":"VintageNet.IP.DhcpdConfig.add_config/3","type":"function","doc":"Add udhcpd configuration commands for running a DHCP server"},{"ref":"VintageNet.IP.DhcpdConfig.html#normalize/1","title":"VintageNet.IP.DhcpdConfig.normalize/1","type":"function","doc":"Normalize the DHCPD parameters in a configuration."},{"ref":"VintageNet.IP.DnsdConfig.html","title":"VintageNet.IP.DnsdConfig","type":"module","doc":"This is a helper module for VintageNet.Technology implementations that use the Busybox DNS server. DNS functionality is only supported for IPv4 configurations using static IP addresses. DNS server parameters are: :port - The port to use (defaults to 53) :ttl - DNS record TTL in seconds (defaults to 120) :records - DNS A records (required) The :records option is a list of name/IP address tuples. For example: [{&quot;example.com&quot;, {1, 2, 3, 4}}] Only IPv4 addresses are supported. Addresses may be specified as strings or tuples, but will be normalized to tuple form before being applied."},{"ref":"VintageNet.IP.DnsdConfig.html#add_config/3","title":"VintageNet.IP.DnsdConfig.add_config/3","type":"function","doc":"Add dnsd configuration commands for running a DNSD server"},{"ref":"VintageNet.IP.DnsdConfig.html#normalize/1","title":"VintageNet.IP.DnsdConfig.normalize/1","type":"function","doc":"Normalize the DNSD parameters in a configuration."},{"ref":"VintageNet.IP.IPv4Config.html","title":"VintageNet.IP.IPv4Config","type":"module","doc":"This is a helper module for VintageNet.Technology implementations that use IPv4. IPv4 configuration is specified under the :ipv4 key in the configuration map. Fields include: :method - :dhcp, :static, or :disabled The :dhcp method currently has no additional fields. The :static method uses the following fields: :address - the IP address :prefix_length - the number of bits in the IP address to use for the subnet (e.g., 24) :netmask - either this or prefix_length is used to determine the subnet. If you have a choice, use prefix_length :gateway - the default gateway for this interface (optional) :name_servers - a list of DNS servers (optional) :domain - DNS search domain (optional) Configuration normalization converts :netmask to :prefix_length."},{"ref":"VintageNet.IP.IPv4Config.html#add_config/3","title":"VintageNet.IP.IPv4Config.add_config/3","type":"function","doc":"Add IPv4 configuration commands for supporting static and dynamic IP addressing"},{"ref":"VintageNet.IP.IPv4Config.html#normalize/1","title":"VintageNet.IP.IPv4Config.normalize/1","type":"function","doc":"Normalize the IPv4 parameters in a configuration."},{"ref":"VintageNet.Interface.html","title":"VintageNet.Interface","type":"module","doc":"Manage a network interface at a very high level This module handles configuring network interfaces, making sure that configuration failures get retried, and then cleaning up after it&#39;s not needed. The actual code that supplies the configuration implements the VintageNet.Technology behaviour."},{"ref":"VintageNet.Interface.html#callback_mode/0","title":"VintageNet.Interface.callback_mode/0","type":"function","doc":""},{"ref":"VintageNet.Interface.html#child_spec/1","title":"VintageNet.Interface.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor in Elixir v1.6+."},{"ref":"VintageNet.Interface.html#configure/1","title":"VintageNet.Interface.configure/1","type":"function","doc":"Configure an interface the low level way with a &quot;raw_config&quot;"},{"ref":"VintageNet.Interface.html#configure/2","title":"VintageNet.Interface.configure/2","type":"function","doc":"Set a configuration on an interface Configurations with invalid parameters raise exceptions. It&#39;s still possible that network configurations won&#39;t work even if they don&#39;t raise, but it should be due to something in the environment. For example, a network cable isn&#39;t plugged in or a WiFi access point is out of range."},{"ref":"VintageNet.Interface.html#get_configuration/1","title":"VintageNet.Interface.get_configuration/1","type":"function","doc":"Return the current configuration"},{"ref":"VintageNet.Interface.html#ioctl/3","title":"VintageNet.Interface.ioctl/3","type":"function","doc":"Run an I/O command on the specified interface"},{"ref":"VintageNet.Interface.html#start_link/1","title":"VintageNet.Interface.start_link/1","type":"function","doc":"Start up an interface Parameters: ifname - which interface"},{"ref":"VintageNet.Interface.html#stop/1","title":"VintageNet.Interface.stop/1","type":"function","doc":"Stop the interface Note that this doesn&#39;t unconfigure it."},{"ref":"VintageNet.Interface.html#to_raw_config/2","title":"VintageNet.Interface.to_raw_config/2","type":"function","doc":"Convert a configuration to a raw one This can be used to validate a configuration without applying it."},{"ref":"VintageNet.Interface.html#unconfigure/1","title":"VintageNet.Interface.unconfigure/1","type":"function","doc":"Unconfigure the interface This doesn&#39;t exit this GenServer, but the interface won&#39;t be usable in any real way until it&#39;s configured again. This function is not normally called."},{"ref":"VintageNet.Interface.html#wait_until_configured/1","title":"VintageNet.Interface.wait_until_configured/1","type":"function","doc":"Wait for the interface to be configured"},{"ref":"VintageNet.Interface.Classification.html","title":"VintageNet.Interface.Classification","type":"module","doc":"Module for classifying and prioritizing network interfaces"},{"ref":"VintageNet.Interface.Classification.html#compute_metric/4","title":"VintageNet.Interface.Classification.compute_metric/4","type":"function","doc":"Compute the routing metric for an interface with a status This uses the prioritization list to figure out what number should be used for the Linux routing table metric. It could also be :disabled to indicate that a route shouldn&#39;t be added to the Linux routing tables at all."},{"ref":"VintageNet.Interface.Classification.html#default_prioritization/0","title":"VintageNet.Interface.Classification.default_prioritization/0","type":"function","doc":"Return a reasonable default for prioritizing interfaces The logic is that Internet-connected interfaces are prioritized first and after than Ethernet is preferred over WiFi and WiFi over LTE."},{"ref":"VintageNet.Interface.Classification.html#to_instance/1","title":"VintageNet.Interface.Classification.to_instance/1","type":"function","doc":"Extract a number out of an interface name The result is the interface index for most interfaces seen on Nerves (eth0, eth1, ...), and something quite imperfect when using predictable interface naming (enp6s0, enp6s1). This is currently used to order priorities when there are two interfaces available of the same type that cannot be differentiated by other means. It has the one property of being easy to explain."},{"ref":"VintageNet.Interface.Classification.html#to_type/1","title":"VintageNet.Interface.Classification.to_type/1","type":"function","doc":"Classify a network type based on its name Examples iex&gt; Classification.to_type(&quot;eth0&quot;) :ethernet iex&gt; Classification.to_type(&quot;wlp5s0&quot;) :wifi iex&gt; Classification.to_type(&quot;ppp0&quot;) :mobile"},{"ref":"VintageNet.Interface.Classification.html#t:connection_status/0","title":"VintageNet.Interface.Classification.connection_status/0","type":"type","doc":"Interface connection status :disconnected - The interface doesn&#39;t exist or it&#39;s not connected :lan - The interface is connected to the LAN, but may not be able reach the Internet :internet - Packets going through the interface should be able to reach the Internet"},{"ref":"VintageNet.Interface.Classification.html#t:interface_type/0","title":"VintageNet.Interface.Classification.interface_type/0","type":"type","doc":"Categorize interfaces based on their technology"},{"ref":"VintageNet.Interface.Classification.html#t:prioritization/0","title":"VintageNet.Interface.Classification.prioritization/0","type":"type","doc":"Prioritization for using default gateways Examples {:ethernet, :internet} - Wired ethernet that&#39;s Internet connected {:ethernet, :_} - Wired ethernet with any status {:_, :internet} - Any Internet-connected network interface"},{"ref":"VintageNet.Interface.Classification.html#t:weight/0","title":"VintageNet.Interface.Classification.weight/0","type":"type","doc":"A weight used to disambiguate interfaces that would otherwise have the same priority Low weights are higher priority."},{"ref":"VintageNet.Interface.CommandRunner.html","title":"VintageNet.Interface.CommandRunner","type":"module","doc":"The CommandRunner module runs commands specified in RawConfigs See the RawConfig documentation for where lists of commands are specified. The following commands are supported: {:run, command, args} - Run a system command {:run_ignore_exit, command, args} - Same as :run, but without the exit status check {:fun, fun} - Run an function CommandRunner also implements RawConfig&#39;s file creation and cleanup logic."},{"ref":"VintageNet.Interface.CommandRunner.html#create_files/1","title":"VintageNet.Interface.CommandRunner.create_files/1","type":"function","doc":"Create a list of files"},{"ref":"VintageNet.Interface.CommandRunner.html#remove_files/1","title":"VintageNet.Interface.CommandRunner.remove_files/1","type":"function","doc":"Remove a list of files"},{"ref":"VintageNet.Interface.CommandRunner.html#run/1","title":"VintageNet.Interface.CommandRunner.run/1","type":"function","doc":"Call a function In general, prefer the module, function_name, args form since it&#39;s easier to check in unit tests. Functions must return :ok or {:error, reason}."},{"ref":"VintageNet.Interface.EAPStatus.html","title":"VintageNet.Interface.EAPStatus","type":"module","doc":"Status of an EAP connection. Keys status Status of the connection. :started - the AP was assosiated and EAP is started. :success - the EAP connection was successful :failure - the EAP connection failed. method - EAP method used to authenticate. See the typespec for available values. timestamp - DateTime of the most recent EAP event. remote_certificate_verified? - if the cert was verified by the EAP server."},{"ref":"VintageNet.Interface.EAPStatus.html#t:method/0","title":"VintageNet.Interface.EAPStatus.method/0","type":"type","doc":"Can be one of: as defined in eap_defs.h in the hostapd source. NONE IDENTITY NOTIFICATION NAK MD5 OTP GTC TLS LEAP SIM TTLS AKA PEAP MSCHAPV2 TLV TNC FAST PAX PSK SAKE IKEV2 AKA_PRIME GPSK PWD EKE TEAP EXPANDED"},{"ref":"VintageNet.Interface.EAPStatus.html#t:t/0","title":"VintageNet.Interface.EAPStatus.t/0","type":"type","doc":""},{"ref":"VintageNet.Interface.InternetConnectivityChecker.html","title":"VintageNet.Interface.InternetConnectivityChecker","type":"module","doc":"This GenServer monitors a network interface for Internet connectivity Internet connectivity is determined by reachability to an IP address. If that address is reachable then other this updates a property to reflect that. Otherwise, the network interface is assumed to merely have LAN connectivity if it&#39;s up."},{"ref":"VintageNet.Interface.InternetConnectivityChecker.html#child_spec/1","title":"VintageNet.Interface.InternetConnectivityChecker.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"VintageNet.Interface.InternetConnectivityChecker.html#start_link/1","title":"VintageNet.Interface.InternetConnectivityChecker.start_link/1","type":"function","doc":"Start the connectivity checker GenServer"},{"ref":"VintageNet.Interface.InternetTester.html","title":"VintageNet.Interface.InternetTester","type":"module","doc":"This module contains functions for testing whether the Internet is available. See the InternetConnectivityChecker for a GenServer that checks on regular intervals and updates VintageNet properties as needed."},{"ref":"VintageNet.Interface.InternetTester.html#ping/1","title":"VintageNet.Interface.InternetTester.ping/1","type":"function","doc":"This &quot;ping&quot;&#39;s a server on the Internet that has a good chance being available The &quot;ping&quot; is really a TCP connection attempt from the specified interface. Failures to connect don&#39;t necessarily mean that the Internet is down, but it&#39;s likely especially if the server that&#39;s specified in the configuration is highly available. Source IP-based routing is required for the TCP connect to go out the right network interface. This is configured by default when using VintageNet."},{"ref":"VintageNet.Interface.InternetTester.html#t:ping_error_reason/0","title":"VintageNet.Interface.InternetTester.ping_error_reason/0","type":"type","doc":""},{"ref":"VintageNet.Interface.LANConnectivityChecker.html","title":"VintageNet.Interface.LANConnectivityChecker","type":"module","doc":"This GenServer monitors a network interface for LAN connectivity Currently LAN connectivity simply looks to see if it&#39;s possible to send a packet on the interface. It might or might not get to the desired destination on the LAN, but it won&#39;t obviously fail. This is an alternative to the InternetConnectivityChecker that actively monitors reachability to a host."},{"ref":"VintageNet.Interface.LANConnectivityChecker.html#child_spec/1","title":"VintageNet.Interface.LANConnectivityChecker.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"VintageNet.Interface.LANConnectivityChecker.html#start_link/1","title":"VintageNet.Interface.LANConnectivityChecker.start_link/1","type":"function","doc":"Start the connectivity checker GenServer"},{"ref":"VintageNet.Interface.RawConfig.html","title":"VintageNet.Interface.RawConfig","type":"module","doc":"Raw configuration for an interface This struct contains the low-level instructions for how to configure and unconfigure an interface. Fields: ifname - the name of the interface (e.g., &quot;eth0&quot;) type - the type of network interface (aka the module that created the config) source_config - the configuration that generated this one require_interface - require the interface to exist in the system before configuring retry_millis - if bringing the interface up fails, wait this amount of time before retrying files - a list of file path, content tuples restart_strategy - the restart strategy for the list of child_specs. I.e., :one_for_one | :one_for_all | :rest_for_one child_specs - a set of child_specs for GenServers to start up and supervise up_cmd_millis - the maximum amount of time to allow the up command list to take up_cmds - a list of commands to run to configure the interface down_cmd_millis - the maximum amount of time to allow the down command list to take down_cmds - a list of commands to run to unconfigure the interface cleanup_files - additional files to delete (the files listed in files are deleted too)"},{"ref":"VintageNet.Interface.RawConfig.html#unimplemented_ioctl/2","title":"VintageNet.Interface.RawConfig.unimplemented_ioctl/2","type":"function","doc":""},{"ref":"VintageNet.Interface.RawConfig.html#t:command/0","title":"VintageNet.Interface.RawConfig.command/0","type":"type","doc":"A command to run for RawConfig.up_cmds or RawConfig.down_cmds"},{"ref":"VintageNet.Interface.RawConfig.html#t:file_contents/0","title":"VintageNet.Interface.RawConfig.file_contents/0","type":"type","doc":""},{"ref":"VintageNet.Interface.RawConfig.html#t:t/0","title":"VintageNet.Interface.RawConfig.t/0","type":"type","doc":""},{"ref":"VintageNet.Interface.Supervisor.html","title":"VintageNet.Interface.Supervisor","type":"module","doc":""},{"ref":"VintageNet.Interface.Supervisor.html#child_spec/1","title":"VintageNet.Interface.Supervisor.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"VintageNet.Interface.Supervisor.html#clear_technology/1","title":"VintageNet.Interface.Supervisor.clear_technology/1","type":"function","doc":"Clear out children and child_specs from a technology"},{"ref":"VintageNet.Interface.Supervisor.html#set_technology/3","title":"VintageNet.Interface.Supervisor.set_technology/3","type":"function","doc":"Add child_specs provided by technologies to supervision"},{"ref":"VintageNet.Interface.Supervisor.html#start_link/1","title":"VintageNet.Interface.Supervisor.start_link/1","type":"function","doc":"Start the interface supervisor"},{"ref":"VintageNet.Interface.Udhcpc.html","title":"VintageNet.Interface.Udhcpc","type":"module","doc":""},{"ref":"VintageNet.Interface.Udhcpc.html#bound/2","title":"VintageNet.Interface.Udhcpc.bound/2","type":"function","doc":"Handle bound reports from udhcpc"},{"ref":"VintageNet.Interface.Udhcpc.html#deconfig/2","title":"VintageNet.Interface.Udhcpc.deconfig/2","type":"function","doc":"Handle deconfig reports from udhcpc"},{"ref":"VintageNet.Interface.Udhcpc.html#leasefail/2","title":"VintageNet.Interface.Udhcpc.leasefail/2","type":"function","doc":"Handle leasefail reports from udhcpc"},{"ref":"VintageNet.Interface.Udhcpc.html#nak/2","title":"VintageNet.Interface.Udhcpc.nak/2","type":"function","doc":"Handle nak reports from udhcpc"},{"ref":"VintageNet.Interface.Udhcpc.html#renew/2","title":"VintageNet.Interface.Udhcpc.renew/2","type":"function","doc":"Handle renew reports from udhcpc"},{"ref":"VintageNet.Interface.Udhcpd.html","title":"VintageNet.Interface.Udhcpd","type":"module","doc":""},{"ref":"VintageNet.Interface.Udhcpd.html#parse_leases/1","title":"VintageNet.Interface.Udhcpd.parse_leases/1","type":"function","doc":"Parse the leases file from udhcpd"},{"ref":"VintageNet.InterfacesMonitor.html","title":"VintageNet.InterfacesMonitor","type":"module","doc":"Monitor available interfaces Currently this works by polling the system for what interfaces are visible. They may or may not be configured."},{"ref":"VintageNet.InterfacesMonitor.html#child_spec/1","title":"VintageNet.InterfacesMonitor.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"VintageNet.InterfacesMonitor.html#force_clear_ipv4_addresses/1","title":"VintageNet.InterfacesMonitor.force_clear_ipv4_addresses/1","type":"function","doc":"Force clear all addresses This is useful to notify everyone that an address should not be used immediately. This can be used to fix a race condition where the blip for an address going away to coming back isn&#39;t reported."},{"ref":"VintageNet.InterfacesMonitor.html#start_link/1","title":"VintageNet.InterfacesMonitor.start_link/1","type":"function","doc":""},{"ref":"VintageNet.InterfacesSupervisor.html","title":"VintageNet.InterfacesSupervisor","type":"module","doc":""},{"ref":"VintageNet.InterfacesSupervisor.html#child_spec/1","title":"VintageNet.InterfacesSupervisor.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"VintageNet.InterfacesSupervisor.html#start_interface/1","title":"VintageNet.InterfacesSupervisor.start_interface/1","type":"function","doc":""},{"ref":"VintageNet.InterfacesSupervisor.html#start_link/1","title":"VintageNet.InterfacesSupervisor.start_link/1","type":"function","doc":""},{"ref":"VintageNet.NameResolver.html","title":"VintageNet.NameResolver","type":"module","doc":"This module manages the contents of &quot;/etc/resolv.conf&quot;. This file is used by the C library for resolving domain names and must be kept up-to-date as links go up and down. This module assumes exclusive ownership on &quot;/etc/resolv.conf&quot;, so if any other code in the system tries to modify the file, their changes will be lost on the next update."},{"ref":"VintageNet.NameResolver.html#child_spec/1","title":"VintageNet.NameResolver.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"VintageNet.NameResolver.html#clear/1","title":"VintageNet.NameResolver.clear/1","type":"function","doc":"Clear all entries in &quot;/etc/resolv.conf&quot; that are associated with the specified interface."},{"ref":"VintageNet.NameResolver.html#clear_all/0","title":"VintageNet.NameResolver.clear_all/0","type":"function","doc":"Completely clear out &quot;/etc/resolv.conf&quot;."},{"ref":"VintageNet.NameResolver.html#setup/3","title":"VintageNet.NameResolver.setup/3","type":"function","doc":"Set the search domain and name server list for the specified interface. This replaces any entries in the /etc/resolv.conf for this interface."},{"ref":"VintageNet.NameResolver.html#start_link/1","title":"VintageNet.NameResolver.start_link/1","type":"function","doc":"Start the resolv.conf manager."},{"ref":"VintageNet.NameResolver.html#stop/0","title":"VintageNet.NameResolver.stop/0","type":"function","doc":"Stop the resolv.conf manager."},{"ref":"VintageNet.NameResolver.html#t:ifmap/0","title":"VintageNet.NameResolver.ifmap/0","type":"type","doc":"Settings for NameResolver"},{"ref":"VintageNet.NameResolver.html#t:state/0","title":"VintageNet.NameResolver.state/0","type":"type","doc":"State of the server."},{"ref":"VintageNet.Persistence.html","title":"VintageNet.Persistence","type":"behaviour","doc":"Customize the way VintageNet saves and loads configurations"},{"ref":"VintageNet.Persistence.html#call/2","title":"VintageNet.Persistence.call/2","type":"function","doc":""},{"ref":"VintageNet.Persistence.html#c:clear/1","title":"VintageNet.Persistence.clear/1","type":"callback","doc":"Clear out a previously saved configuration"},{"ref":"VintageNet.Persistence.html#c:enumerate/0","title":"VintageNet.Persistence.enumerate/0","type":"callback","doc":"Enumerate the interfaces that have saved configurations This returns a list of interface names."},{"ref":"VintageNet.Persistence.html#c:load/1","title":"VintageNet.Persistence.load/1","type":"callback","doc":"Load the configuration of an interface"},{"ref":"VintageNet.Persistence.html#c:save/2","title":"VintageNet.Persistence.save/2","type":"callback","doc":"Save the configuration for the specified interface"},{"ref":"VintageNet.Persistence.FlatFile.html","title":"VintageNet.Persistence.FlatFile","type":"module","doc":"Save and load configurations from flat files"},{"ref":"VintageNet.Persistence.Null.html","title":"VintageNet.Persistence.Null","type":"module","doc":"Don&#39;t save or load configuration at all."},{"ref":"VintageNet.PropertyTable.html","title":"VintageNet.PropertyTable","type":"module","doc":"PropertyTables are in-memory key-value stores Users can subscribe to keys or groups of keys to be notified of changes. Keys are hierarchically layed out with each key being represented as a list for the path to the key. For example, to get the current state of the network interface eth0, you would get the value of the key, [&quot;net&quot;, &quot;ethernet&quot;, &quot;eth0&quot;]. Values can be any Elixir data structure except for nil. nil is used to identify non-existent keys. Therefore, setting a property to nil deletes the property. Users can get and listen for changes in multiple keys by specifying prefix paths. For example, if you wants to get every network property, run: PropertyTable.get_by_prefix(table, [&quot;net&quot;]) Likewise, you can subscribe to changes in the network status by running: PropertyTable.subscribe(table, [&quot;net&quot;]) Properties can include metadata. PropertyTable only specifies that metadata is a map."},{"ref":"VintageNet.PropertyTable.html#child_spec/1","title":"VintageNet.PropertyTable.child_spec/1","type":"function","doc":"Returns a specification to start a property_table under a supervisor. See Supervisor."},{"ref":"VintageNet.PropertyTable.html#clear/2","title":"VintageNet.PropertyTable.clear/2","type":"function","doc":"Clear out a property"},{"ref":"VintageNet.PropertyTable.html#clear_prefix/2","title":"VintageNet.PropertyTable.clear_prefix/2","type":"function","doc":"Clear out all properties under a prefix"},{"ref":"VintageNet.PropertyTable.html#get/3","title":"VintageNet.PropertyTable.get/3","type":"function","doc":"Get the current value of a property"},{"ref":"VintageNet.PropertyTable.html#get_by_prefix/2","title":"VintageNet.PropertyTable.get_by_prefix/2","type":"function","doc":"Get a list of all properties matching the specified prefix"},{"ref":"VintageNet.PropertyTable.html#match/2","title":"VintageNet.PropertyTable.match/2","type":"function","doc":"Get a list of all properties matching the specified prefix"},{"ref":"VintageNet.PropertyTable.html#put/4","title":"VintageNet.PropertyTable.put/4","type":"function","doc":"Update a property and notify listeners"},{"ref":"VintageNet.PropertyTable.html#start_link/1","title":"VintageNet.PropertyTable.start_link/1","type":"function","doc":""},{"ref":"VintageNet.PropertyTable.html#subscribe/2","title":"VintageNet.PropertyTable.subscribe/2","type":"function","doc":"Subscribe to receive events"},{"ref":"VintageNet.PropertyTable.html#unsubscribe/2","title":"VintageNet.PropertyTable.unsubscribe/2","type":"function","doc":"Stop subscribing to a property"},{"ref":"VintageNet.PropertyTable.html#t:metadata/0","title":"VintageNet.PropertyTable.metadata/0","type":"type","doc":""},{"ref":"VintageNet.PropertyTable.html#t:property/0","title":"VintageNet.PropertyTable.property/0","type":"type","doc":"Properties"},{"ref":"VintageNet.PropertyTable.html#t:property_with_wildcards/0","title":"VintageNet.PropertyTable.property_with_wildcards/0","type":"type","doc":""},{"ref":"VintageNet.PropertyTable.html#t:table_id/0","title":"VintageNet.PropertyTable.table_id/0","type":"type","doc":"A table_id identifies a group of properties"},{"ref":"VintageNet.PropertyTable.html#t:value/0","title":"VintageNet.PropertyTable.value/0","type":"type","doc":""},{"ref":"VintageNet.Route.Calculator.html","title":"VintageNet.Route.Calculator","type":"module","doc":"This module computes the desired routing table contents It&#39;s used by the RouteManager to update the Linux routing tables when interfaces come online or change state. See the RouteManager docs for a discussion of how routes are configured. The functions in this module have no side effects so that it&#39;s easier to test that routing scenarios result in correct Linux routing table configurations."},{"ref":"VintageNet.Route.Calculator.html#compute/3","title":"VintageNet.Route.Calculator.compute/3","type":"function","doc":"Compute a Linux routing table configuration The entries are ordered so that List.myers_difference/2 can be used to minimize the routing table changes."},{"ref":"VintageNet.Route.Calculator.html#init/0","title":"VintageNet.Route.Calculator.init/0","type":"function","doc":"Initialize state carried between calculations"},{"ref":"VintageNet.Route.Calculator.html#rule_table_index_range/0","title":"VintageNet.Route.Calculator.rule_table_index_range/0","type":"function","doc":"Return the table indices used for routing based on source IP."},{"ref":"VintageNet.Route.Calculator.html#t:default_route/0","title":"VintageNet.Route.Calculator.default_route/0","type":"type","doc":""},{"ref":"VintageNet.Route.Calculator.html#t:entries/0","title":"VintageNet.Route.Calculator.entries/0","type":"type","doc":""},{"ref":"VintageNet.Route.Calculator.html#t:entry/0","title":"VintageNet.Route.Calculator.entry/0","type":"type","doc":""},{"ref":"VintageNet.Route.Calculator.html#t:interface_infos/0","title":"VintageNet.Route.Calculator.interface_infos/0","type":"type","doc":""},{"ref":"VintageNet.Route.Calculator.html#t:local_route/0","title":"VintageNet.Route.Calculator.local_route/0","type":"type","doc":""},{"ref":"VintageNet.Route.Calculator.html#t:metric/0","title":"VintageNet.Route.Calculator.metric/0","type":"type","doc":""},{"ref":"VintageNet.Route.Calculator.html#t:rule/0","title":"VintageNet.Route.Calculator.rule/0","type":"type","doc":""},{"ref":"VintageNet.Route.Calculator.html#t:table_index/0","title":"VintageNet.Route.Calculator.table_index/0","type":"type","doc":""},{"ref":"VintageNet.Route.Calculator.html#t:table_indices/0","title":"VintageNet.Route.Calculator.table_indices/0","type":"type","doc":""},{"ref":"VintageNet.Route.IPRoute.html","title":"VintageNet.Route.IPRoute","type":"module","doc":"This module knows how to invoke the ip command to modify the Linux routing tables"},{"ref":"VintageNet.Route.IPRoute.html#add_default_route/4","title":"VintageNet.Route.IPRoute.add_default_route/4","type":"function","doc":"Add a default route"},{"ref":"VintageNet.Route.IPRoute.html#add_local_route/5","title":"VintageNet.Route.IPRoute.add_local_route/5","type":"function","doc":"Add a local route"},{"ref":"VintageNet.Route.IPRoute.html#add_rule/2","title":"VintageNet.Route.IPRoute.add_rule/2","type":"function","doc":"Add a source IP address -&gt; routing table rule"},{"ref":"VintageNet.Route.IPRoute.html#clear_a_local_route/1","title":"VintageNet.Route.IPRoute.clear_a_local_route/1","type":"function","doc":"Clear one local route generically"},{"ref":"VintageNet.Route.IPRoute.html#clear_a_local_route/5","title":"VintageNet.Route.IPRoute.clear_a_local_route/5","type":"function","doc":"Clear one local route"},{"ref":"VintageNet.Route.IPRoute.html#clear_a_route/0","title":"VintageNet.Route.IPRoute.clear_a_route/0","type":"function","doc":"Clear one default route out of the main table for any interface"},{"ref":"VintageNet.Route.IPRoute.html#clear_a_route/2","title":"VintageNet.Route.IPRoute.clear_a_route/2","type":"function","doc":"Clear one default route that goes to the specified interface"},{"ref":"VintageNet.Route.IPRoute.html#clear_a_rule/1","title":"VintageNet.Route.IPRoute.clear_a_rule/1","type":"function","doc":"Clear out one rule"},{"ref":"VintageNet.Route.IPRoute.html#clear_all_routes/0","title":"VintageNet.Route.IPRoute.clear_all_routes/0","type":"function","doc":"Clear all routes on all interfaces"},{"ref":"VintageNet.Route.IPRoute.html#clear_all_rules/1","title":"VintageNet.Route.IPRoute.clear_all_rules/1","type":"function","doc":"Clear all rules that select the specified table or tables"},{"ref":"VintageNet.Route.Properties.html","title":"VintageNet.Route.Properties","type":"module","doc":"This module contains helpers for updating the global routing properties. These include: [&quot;available_interfaces&quot;] [&quot;connection&quot;]"},{"ref":"VintageNet.Route.Properties.html#update_available_interfaces/1","title":"VintageNet.Route.Properties.update_available_interfaces/1","type":"function","doc":"Update the available_interfaces property based on the low level routes This function orders interfaces based on metric just like Linux does"},{"ref":"VintageNet.Route.Properties.html#update_best_connection/1","title":"VintageNet.Route.Properties.update_best_connection/1","type":"function","doc":"Update the overall connection status :disconnected &lt; :lan &lt; :internet"},{"ref":"VintageNet.RouteManager.html","title":"VintageNet.RouteManager","type":"module","doc":"This module manages the default route. Devices with more than one network interface may have more than one way of reaching the Internet. The routing table decides which interface an IP packet should use by looking at the &quot;default route&quot; entries. One interface is chosen. Since not all interfaces are equal, we&#39;d like Linux to pick the fastest and lowest latency one. for example, one could prefer wired Ethernet over WiFi and prefer WiFi over a cellular connection. This module lets you specify an ordering for interfaces and sets up the routes based on this ordering. This module also handles networking failures. One failure that Linux can&#39;t figure out on its own is whether an interface can reach the Internet. Internet reachability is handled elsewhere like in the ConnectivityChecker module. This module should be told reachability status so that it can properly order default routes so that the best reachable interface is used. IMPORTANT: This module uses priority-based routing. Make sure the following kernel options are enabled: CONFIG_IP_ADVANCED_ROUTER=y CONFIG_IP_MULTIPLE_TABLES=y"},{"ref":"VintageNet.RouteManager.html#child_spec/1","title":"VintageNet.RouteManager.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"VintageNet.RouteManager.html#clear_route/1","title":"VintageNet.RouteManager.clear_route/1","type":"function","doc":"Clear out the default gateway for an interface."},{"ref":"VintageNet.RouteManager.html#set_connection_status/2","title":"VintageNet.RouteManager.set_connection_status/2","type":"function","doc":"Set the connection status on an interface. Changing the connection status can re-prioritize routing. The specified interface doesn&#39;t need to have a default route."},{"ref":"VintageNet.RouteManager.html#set_prioritization/1","title":"VintageNet.RouteManager.set_prioritization/1","type":"function","doc":"Set the order that default gateways should be used The list is ordered from highest priority to lowest"},{"ref":"VintageNet.RouteManager.html#set_route/4","title":"VintageNet.RouteManager.set_route/4","type":"function","doc":"Set the default route for an interface. This replaces any existing routes on that interface"},{"ref":"VintageNet.RouteManager.html#start_link/1","title":"VintageNet.RouteManager.start_link/1","type":"function","doc":"Start the route manager."},{"ref":"VintageNet.RouteManager.html#stop/0","title":"VintageNet.RouteManager.stop/0","type":"function","doc":"Stop the route manager."},{"ref":"VintageNet.Technology.html","title":"VintageNet.Technology","type":"behaviour","doc":"Technologies define how network interface types work VintageNet comes with several built-in technologies, but more can be added or existing ones modified by implementing the Technology behaviour."},{"ref":"VintageNet.Technology.html#c:check_system/1","title":"VintageNet.Technology.check_system/1","type":"callback","doc":"Check that the system has all of the required programs for this technology This is intended to help identify missing programs without configuring a network."},{"ref":"VintageNet.Technology.html#c:ioctl/3","title":"VintageNet.Technology.ioctl/3","type":"callback","doc":"Handle an ioctl that has been requested on the network interface The function runs isolated in its own process and only one ioctl is guaranteed to be running at a time. VintageNet will handle crashes and hangs and unceremoniously kill the ioctl if the user changes their mind and reconfigures the network interface. Ioctl support is optional. Examples of ioctls include: :scan - scan for WiFi networks :statistics - return a map of network statistics"},{"ref":"VintageNet.Technology.html#c:normalize/1","title":"VintageNet.Technology.normalize/1","type":"callback","doc":"Normalize a configuration Technologies use this to update input configurations to a canonical representation. This includes things like inserting default fields, converting IP addresses passed in as strings to tuples, and deriving parameters so that they need not be derived again in the future. Configuration errors raise exceptions."},{"ref":"VintageNet.Technology.html#c:to_raw_config/3","title":"VintageNet.Technology.to_raw_config/3","type":"callback","doc":"Convert a technology-specific configuration to one for VintageNet Configuration errors raise exceptions."},{"ref":"VintageNet.Technology.Null.html","title":"VintageNet.Technology.Null","type":"module","doc":"An interface with this technology is unconfigured"},{"ref":"VintageNet.ToElixir.Server.html","title":"VintageNet.ToElixir.Server","type":"module","doc":"This GenServer routes messages from C and shell scripts to the appropriate places in VintageNet."},{"ref":"VintageNet.ToElixir.Server.html#child_spec/1","title":"VintageNet.ToElixir.Server.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"VintageNet.ToElixir.Server.html#start_link/1","title":"VintageNet.ToElixir.Server.start_link/1","type":"function","doc":"Start the GenServer."},{"ref":"VintageNet.ToElixir.UdhcpcHandler.html","title":"VintageNet.ToElixir.UdhcpcHandler","type":"behaviour","doc":"A behaviour for handling notifications from udhcpc Example defmodule MyApp.UdhcpcHandler do @behaviour VintageNet.ToElixir.UdhcpcHandler @impl true def deconfig(ifname, data) do ... end end To have VintageNet invoke it, add the following to your config.exs: config :vintage_net, udhcpc_handler: MyApp.UdhcpcHandler"},{"ref":"VintageNet.ToElixir.UdhcpcHandler.html#c:bound/2","title":"VintageNet.ToElixir.UdhcpcHandler.bound/2","type":"callback","doc":"Handle an assignment from the DHCP server"},{"ref":"VintageNet.ToElixir.UdhcpcHandler.html#c:deconfig/2","title":"VintageNet.ToElixir.UdhcpcHandler.deconfig/2","type":"callback","doc":"Deconfigure the specified interface"},{"ref":"VintageNet.ToElixir.UdhcpcHandler.html#dispatch/3","title":"VintageNet.ToElixir.UdhcpcHandler.dispatch/3","type":"function","doc":"Called internally by vintage_net to dispatch calls"},{"ref":"VintageNet.ToElixir.UdhcpcHandler.html#c:leasefail/2","title":"VintageNet.ToElixir.UdhcpcHandler.leasefail/2","type":"callback","doc":"Handle a failure to get a lease"},{"ref":"VintageNet.ToElixir.UdhcpcHandler.html#c:nak/2","title":"VintageNet.ToElixir.UdhcpcHandler.nak/2","type":"callback","doc":"Handle a DHCP NAK"},{"ref":"VintageNet.ToElixir.UdhcpcHandler.html#c:renew/2","title":"VintageNet.ToElixir.UdhcpcHandler.renew/2","type":"callback","doc":"Handle the renewal of a DHCP lease"},{"ref":"VintageNet.ToElixir.UdhcpcHandler.html#t:update_data/0","title":"VintageNet.ToElixir.UdhcpcHandler.update_data/0","type":"type","doc":""},{"ref":"VintageNet.ToElixir.UdhcpdHandler.html","title":"VintageNet.ToElixir.UdhcpdHandler","type":"behaviour","doc":"A behaviour for handling notifications from udhcpd Example defmodule MyApp.UdhcpdHandler do @behaviour VintageNet.ToElixir.UdhcpdHandler @impl true def lease_update(ifname, report_data) do ... end end To have VintageNet invoke it, add the following to your config.exs: config :vintage_net, udhcpd_handler: MyApp.UdhcpdHandler"},{"ref":"VintageNet.ToElixir.UdhcpdHandler.html#dispatch/3","title":"VintageNet.ToElixir.UdhcpdHandler.dispatch/3","type":"function","doc":"Called internally by vintage_net to dispatch calls"},{"ref":"VintageNet.ToElixir.UdhcpdHandler.html#c:lease_update/2","title":"VintageNet.ToElixir.UdhcpdHandler.lease_update/2","type":"callback","doc":"The DHCP lease file was updated"},{"ref":"VintageNet.ToElixir.UdhcpdHandler.html#t:update_data/0","title":"VintageNet.ToElixir.UdhcpdHandler.update_data/0","type":"type","doc":""},{"ref":"readme.html","title":"README","type":"extras","doc":"NOTE: If you&#39;ve been using vintage_net v0.6.x or earlier, we split out network technology support out to separate libraries in v0.7.0. You&#39;ll need to add those libraries to your mix dependency list and rename some atoms. Configurations stored on deployed devices will be automatically updated. See the v0.7.0 release notes for details. VintageNet is network configuration library built specifically for Nerves Project devices. It has the following features: Ethernet and WiFi support included. Extendible to other technologies Default configurations specified in your Application config Runtime updates to configurations are persisted and applied on next boot (configurations are obfuscated by default to hide WiFi passphrases) Simple subscription to network status change events Connect to multiple networks at a time and prioritize which interfaces are used (Ethernet over WiFi over cellular) Internet connection monitoring and failure detection TL;DR: Don&#39;t care about any of this and just want the string to copy/paste to set up networking? See the VintageNet Cookbook. The following network configurations are supported: [x] Wired Ethernet, IPv4 DHCP [x] Wired Ethernet, IPv4 static IP [x] WiFi password-less and WEP [x] WPA2 PSK and EAP [x] USB gadget mode Ethernet, IPv4 DHCP server to supply host IP address [ ] Cellular networks [x] WiFi AP mode [ ] IPv6 vintage_net takes a different approach to networking from nerves_network. Its focus is on building and applying network configurations. Where nerves_network provided configurable state machines, vintage_net turns human-readable configurations into everything from configuration files and calls to ip to starting up networking GenServers and routing table updates. This makes it easier to add support for new network technologies and features. While Elixir and Erlang were great to implement network protocols in, it was frequently more practical to reuse embedded Linux implementations. Importantly, though, vintage_net monitors Linux daemons under its OTP supervision tree so failures on both the &quot;C&quot; and Elixir sides propagate in the expected ways. Another important difference is that VintageNet doesn&#39;t attempt to make incremental modifications to configurations. It completely tears down an interface&#39;s connection and then brings up new configurations in a fresh state. Network reconfiguration is assumed to be an infrequent event so while this can cause a hiccup in the network connectivity, it removes state machine code that made nerves_network hard to maintain."},{"ref":"readme.html#installation","title":"README - Installation","type":"extras","doc":"First, if you&#39;re modifying an existing project, you will need to remove nerves_network and nerves_init_gadget. vintage_net doesn&#39;t work with either of them. You&#39;ll get an error if any project references those packages. There are two routes to integrating vintage_net: Use nerves_pack. nerves_pack is like nerves_init_gadget, but for vintage_net. Copy and paste from vintage_net_example The next step is to make sure that your Nerves system is compatible. The official Nerves systems released after 12/11/2019 work without modification. If rolling your own Nerves port, you will need the following Linux kernel options enabled: CONFIG_IP_ADVANCED_ROUTER=y CONFIG_IP_MULTIPLE_TABLES=y Then make sure that you have the following Busybox options enabled: CONFIG_IFCONFIG=y - ifconfig ifconfig CONFIG_UDHCPC=y - udhcpc DHCP Client CONFIG_UDHCPD=y - udhcpd DHCP Server (optional) You can avoid making the Busybox changes by adding :busybox to your project&#39;s mix dependencies: {:busybox, &quot;~&gt; 0.1&quot;, targets: @all_targets} Finally, you&#39;ll need to choose what network connection technologies that you want available in your firmware. If using nerves_pack, you&#39;ll get support for wired Ethernet, WiFi, and USB gadget networking automatically. Otherwise, add one or more of the following to your dependency list: vintage_net_ethernet - Standard wired Ethernet vintage_net_wifi - Client configurations for 802.11 WiFi vintage_net_direct - Direct connections like those used for USB gadget"},{"ref":"readme.html#configuration","title":"README - Configuration","type":"extras","doc":"VintageNet has many application configuration keys. Most defaults are fine. At a minimum, you&#39;ll want to specify a default configuration and default regulatory domain if using WiFi. In your main config.exs, add the following: config :vintage_net, regulatory_domain: &quot;US&quot;, config: [ {&quot;eth0&quot;, %{type: VintageNetEthernet, ipv4: %{method: :dhcp}}}, {&quot;wlan0&quot;, %{type: VintageNetWiFi}} ] This sets the regulatory domain to the US (set to your ISO 3166-1 alpha-2 country code. This code is passed on to the drivers for WiFi and other wireless networking technologies so that they comply with local regulations. If you need a global default, set to &quot;00&quot; or don&#39;t set at all. Unfortunately, this may mean that an access point isn&#39;t visible if it is running on a frequency that&#39;s allowed in your country, but not globally. The config section is a list of network configurations. The one shown above configures DHCP on wired Ethernet and minimally starts up a WiFi LAN so that it&#39;s possible to scan for networks. The typical setup is to provide generic defaults here. Static IP addresses, WiFi SSIDs and credentials are more appropriately configured at run-time. VintageNet persists configurations too. Details on network configuration are described later. The following table describes the other application config keys. KeyDescription configA list of default network configurations tmpdirPath to a temporary directory for VintageNet to_elixir_socketName to use for the Unix domain socket for C to Elixir communication bin_ifupPath to ifup bin_ifdownPath to ifdown bin_chatPath to chat bin_pppdPath to pppd bin_mknodPath to mknod bin_killallPath to killall bin_wpa_supplicantPath to wpa_supplicant bin_ipPath to ip udhcpc_handlerModule for handling notifications from udhcpc resolvconfPath to /etc/resolv.conf persistenceModule for persisting network configurations persistence_dirPath to a directory for storing persisted configurations persistence_secretA 16-byte secret or an MFA for getting a secret internet_hostIP address for host to ping to check for Internet connectivity. Must be a tuple of integers ({1, 1, 1, 1}) or binary representation (&quot;1.1.1.1&quot;) regulatory_domainISO 3166-1 alpha-2 country (00 for global, US, etc.)"},{"ref":"readme.html#network-interface-configuration","title":"README - Network interface configuration","type":"extras","doc":"VintageNet supports several network technologies out of the box and third-party libraries can provide more via the VintageNet.Technology behaviour. Configurations are Elixir maps. These are specified in three places: The vintage_net application config (e.g., your config.exs) Locally saved configuration (see the VintageNet.Persistence behaviour for replacing the default) Calling VintageNet.configure/2 to change the configuration at run-time When vintage_net starts, it applies saved configurations first and if any thing is wrong with those configs, it reverts to the application config. A good practice is to have safe defaults for all network interfaces in the application config. The only required key in the configuration maps is :type. All other keys follow from the type. :type should be set to a module that implements the VintageNet.Technology behaviour. The following are common technologies: VintageNetEthernet - Standard wired Ethernet VintageNetWiFi - Client configurations for 802.11 WiFi VintageNetDirect - Direct connections like those used for USB gadget connections VintageNet.Technology.Null - An empty configuration useful for turning off a configuration See the links above for specific documentation."},{"ref":"readme.html#persistence","title":"README - Persistence","type":"extras","doc":"By default, VintageNet stores network configuration to disk. If you are migrating from nerves_network you may already have a persistence implementation. To disable the default persistence, configure vintage_net as follows: config :vintage_net, persistence: VintageNet.Persistence.Null"},{"ref":"readme.html#debugging","title":"README - Debugging","type":"extras","doc":"Debugging networking issues is not fun. When you&#39;re starting out with vintage_net, it is highly recommended to connect to your target using a method that doesn&#39;t require networking to work. This could be a UART connection to an IEx console on a Nerves device or maybe just hooking up a keyboard and monitor. If having trouble, first check VintageNet.info() to verify the configuration and connection status: iex&gt; VintageNet.info VintageNet 0.3.0 All interfaces: [&quot;eth0&quot;, &quot;lo&quot;, &quot;tap0&quot;, &quot;wlan0&quot;] Available interfaces: [&quot;eth0&quot;, &quot;wlan0&quot;] Interface eth0 Type: VintageNetEthernet Present: true State: :configured Connection: :internet Configuration: %{ipv4: %{method: :dhcp}, type: VintageNetEthernet} Interface wlan0 Type: VintageNetWiFi Present: true State: :configured Connection: :internet Configuration: %{ ipv4: %{method: :dhcp}, type: VintageNetWiFi, wifi: %{ key_mgmt: :wpa_psk, mode: :infrastructure, psk: &quot;******&quot;, ssid: &quot;MyLAN&quot; } } If you&#39;re using Toolshed, try running the following: iex&gt; ifconfig lo: flags=[:up, :loopback, :running] inet 127.0.0.1 netmask 255.0.0.0 inet ::1 netmask ffff:ffff:ffff:ffff:ffff:ffff:ffff:ffff hwaddr 00:00:00:00:00:00 eth0: flags=[:up, :broadcast, :running, :multicast] inet 192.168.9.131 netmask 255.255.255.0 broadcast 192.168.9.255 inet fe80::6264:5ff:fee1:4045 netmask ffff:ffff:ffff:ffff:: hwaddr 60:64:05:e1:40:45 wlan0: flags=[:up, :broadcast, :running, :multicast] inet 192.168.9.175 netmask 255.255.255.0 broadcast 192.168.9.255 inet fe80::20c:e7ff:fe11:3d46 netmask ffff:ffff:ffff:ffff:: hwaddr 00:0c:e7:11:3d:46 Or ping: iex&gt; ping &quot;nerves-project.com&quot; Press enter to stop Response from nerves-project.com (96.126.123.244): time=48.87ms Response from nerves-project.com (96.126.123.244): time=42.856ms Response from nerves-project.com (96.126.123.244): time=43.097ms You can also specify an interface to use with ping: iex&gt; ping &quot;nerves-project.com&quot;, ifname: &quot;wlan0&quot; Press enter to stop Response from nerves-project.com (96.126.123.244): time=57.817ms Response from nerves-project.com (96.126.123.244): time=46.796ms iex&gt; ping &quot;nerves-project.com&quot;, ifname: &quot;eth0&quot; Press enter to stop Response from nerves-project.com (96.126.123.244): time=47.923ms Response from nerves-project.com (96.126.123.244): time=48.688ms If it looks like nothing is working, check the logs. On Nerves devices, this is frequently done by calling RingLogger.next or RingLogger.attach. At a last resort, please open a GitHub issue. We would be glad to help. We only have one ask and that is that you get us started with an improvement to our documentation or code so that the next person to run into the issue will have an easier time. Thanks!"},{"ref":"readme.html#properties","title":"README - Properties","type":"extras","doc":"VintageNet maintains a key/value store for retrieving information on networking information: iex&gt; VintageNet.get([&quot;interface&quot;, &quot;eth0&quot;, &quot;connection&quot;]) :internet iex&gt; VintageNet.get_by_prefix([]) [ {[&quot;interface&quot;, &quot;eth0&quot;, &quot;connection&quot;], :internet}, {[&quot;interface&quot;, &quot;eth0&quot;, &quot;state&quot;], :configured}, {[&quot;interface&quot;, &quot;eth0&quot;, &quot;type&quot;], VintageNetEthernet}, {[&quot;interface&quot;, &quot;wlan0&quot;, &quot;connection&quot;], :internet}, {[&quot;interface&quot;, &quot;wlan0&quot;, &quot;state&quot;], :configured}, {[&quot;interface&quot;, &quot;wlan0&quot;, &quot;type&quot;], VintageNetWiFi} ] You can also subscribe to keys and receive a message every time it or one its child keys changes: iex&gt; VintageNet.subscribe([&quot;interface&quot;, &quot;eth0&quot;]) :ok iex&gt; flush {VintageNet, [&quot;interface&quot;, &quot;eth0&quot;, &quot;state&quot;], :configuring, :configured, %{}} The message format is {VintageNet, name, old_value, new_value, metadata} Global properties PropertyValuesDescription available_interfaces[eth0, ...]Currently available network interfaces in priority order. E.g., the first one is used by default connection:disconnected, :lan, :internetThe overall network connection status. This is the best status of all interfaces. Common network interface properties All network interface properties can be found under [&quot;interface&quot;, ifname] in the PropertyTable. The following table lists out properties common to all interfaces: PropertyValuesDescription typeVintageNetEthernet, etc.The type of the interface state:configured, :configuring, etc.The state of the interface from VintageNet&#39;s point of view. connection:disconnected, :lan, :internetThis provides a determination of the Internet connection status lower_uptrue or falseThis indicates whether the physical layer is &quot;up&quot;. E.g., a cable is connected or WiFi associated mac_address&quot;11:22:33:44:55:66&quot;The interface&#39;s MAC address as a string addresses[address_info]This is a list of all of the addresses assigned to this interface Specific types of interfaces provide more parameters."},{"ref":"cookbook.html","title":"VintageNet Cookbook","type":"extras","doc":"VintageNet Cookbook Not sure what to pass to vintage_net? Take a look below for example configurations."},{"ref":"cookbook.html#compile-time-vs-run-time","title":"VintageNet Cookbook - Compile-time vs. run-time","type":"extras","doc":"The examples below all show the options to pass. Where you copy those depends on whether you want the configuration to be a built-in default (i.e., compile-time) or whether you want to change it at run-time. For compile-time, add something like the following to your config.exs: config :vintage_net, config: [ {&quot;eth0&quot;, %{type: VintageNetEthernet, ipv4: %{method: :dhcp}}}, ] But replace &quot;eth0&quot; with the interface and the map with the desired configuration from below. For run-time, call VintageNet.configure like this: VintageNet.configure(&quot;eth0&quot;, %{type: VintageNetEthernet, ipv4: %{method: :dhcp}}}) To see the current configuration at an IEx prompt, type: iex&gt; VintageNet.info"},{"ref":"cookbook.html#network-interface-names","title":"VintageNet Cookbook - Network interface names","type":"extras","doc":"In order to configure a network interface, you will need to know its name. vintage_net passes names through from Nerves or embedded Linux depending on where it&#39;s being run. The following names are common: &quot;eth0&quot; - The first wired Ethernet interface &quot;wlan0&quot; - The first WiFi interface &quot;usb0&quot; - The first virtual Ethernet interface over a USB cable The operating system assigns network interface names as it discovers them. If you&#39;re running on a device with multiple of the same type of interface, the device names may be renamed to make them deterministic. An example is &quot;enp6s0&quot; where the p6 and s0 indicate where the adapter and Ethernet connector location. Running ifconfig on Linux and Nerves can help find these if you are unsure."},{"ref":"cookbook.html#wired-ethernet","title":"VintageNet Cookbook - Wired Ethernet","type":"extras","doc":"To use, make sure that you&#39;re either using nerves_pack or have :vintage_net_ethernet in your deps: {:vintage_net_ethernet, &quot;~&gt; 0.7&quot;} Wired Ethernet with DHCP This is regular wired Ethernet - nothing fancy: %{type: VintageNetEthernet, ipv4: %{method: :dhcp}}} Wired Ethernet with a static IP Update the parameters below as appropriate: %{ type: VintageNetEthernet, ipv4: %{ method: :static, address: &quot;192.168.9.232&quot;, prefix_length: 24, gateway: &quot;192.168.9.1&quot;, name_servers: [&quot;1.1.1.1&quot;] } } See VintageNet.IP.IPv4Config for other options. If you&#39;re interfacing with other Erlang and Elixir libraries, you may find passing IP tuples more convenient than passing strings. That works too."},{"ref":"cookbook.html#wifi","title":"VintageNet Cookbook - WiFi","type":"extras","doc":"To use, make sure that you&#39;re either using nerves_pack or have :vintage_net_wifi in your deps: {:vintage_net_wifi, &quot;~&gt; 0.7&quot;} Normal password-protected WiFi (WPA2 PSK) Most password-protected home networks use WPA2 authentication and pre-shared keys. %{ type: VintageNetWiFi, vintage_net_wifi: %{ networks: [ %{ key_mgmt: :wpa_psk, ssid: &quot;my_network_ssid&quot;, psk: &quot;a_passphrase_or_psk&quot; } ] }, ipv4: %{method: :dhcp}, } Enterprise WiFi (PEAPv0/EAP-MSCHAPV2) Protected EAP (PEAP) is a common authentication protocol for enterprise WiFi networks. %{ type: VintageNetWiFi, vintage_net_wifi: %{ networks: [ %{ key_mgmt: :wpa_eap, ssid: &quot;my_network_ssid&quot;, identity: &quot;username&quot;, password: &quot;password&quot;, eap: &quot;PEAP&quot;, phase2: &quot;auth=MSCHAPV2&quot; } ] }, ipv4: %{method: :dhcp} } Enterprise WiFi (EAP-TLS) TBD Access point WiFi Some WiFi modules can be run in access point mode. This makes it possible to create configuration wizards and captive portals. Configuration of this is more involved. Here is a basic configuration: %{ type: VintageNetWiFi, vintage_net_wifi: %{ networks: [ %{ mode: :ap, ssid: &quot;test ssid&quot;, key_mgmt: :none } ] }, ipv4: %{ method: :static, address: &quot;192.168.24.1&quot;, netmask: &quot;255.255.255.0&quot; }, dhcpd: %{ start: &quot;192.168.24.2&quot;, end: &quot;192.168.24.10&quot; } } See the vintage_net_wizard for an example of a project that uses AP mode and a web server for WiFi configuration."},{"ref":"cookbook.html#network-interaction","title":"VintageNet Cookbook - Network interaction","type":"extras","doc":"Share WAN with other networks For sharing your WANs connection (e.g. internet access) with other networks iptables must be installed. Currently this means building a custom nerves system. Once this is done the following commands need to be called on each boot: wan = &quot;eth0&quot; cmd &quot;sysctl -w net.ipv4.ip_forward=1&quot; cmd &quot;iptables -t nat -A POSTROUTING -o \#{wan} -j MASQUERADE&quot; # Only needed if the connection is blocked otherwise (like a default policy of DROP) cmd &quot;iptables -A INPUT -i \#{wan} -m state --state RELATED,ESTABLISHED -j ACCEPT&quot;"}]